// plugin script :
displayname="Google Translate";
versionstring="1.0.0";
releasedatestring="30.1.2008";
author="Oldrich Svec";
updateurl="";
homepageurl="";
shortdescription="Google Translate";
longdescription="This plugin uses http://translate.google.com/.";
advconfigstring="Google Translate";
readmestring="Google Translate";
iconfilename="favicon.ico";

aliasstr="gt";
regexstr="^gt (\\d{1,2}) (\\d{1,2}) (.*) $|^gt (\\D.*) $";
scriptregex=/^gt (\d{1,2}) (\d{1,2}) (.*) $|^gt (\D.*) $/;
scriptregex2=/^gt \d{1,2} \d{1,2} .* .*$|^gt \D.* .*$/;
regexfilterstr="";
keywordstr="";
scorestr="300";

// type
UNKNOWN=0; FILE=1; FOLDER=2; ALIAS=3; URL=4; PLUGIN=5; CLIP=5;
// Postprocessing
IMMEDIATE_DISPLAY=0; ADDSCORE=1; MATCH_AGAINST_SEARCH=2;
// search state
STOPPED=0; SEARCHING=1;

var pre_results, output, welcome_screen, last_lang = new Array(4,6), languages = new Array("ar","zh-CN","zh-TW","nl","en","fr","de","el","it","ja","ko","pt","ru","es");

//string.dec2char();  string.char2dec();
(function(){var unicode={'dec2hex':function(ts){return(ts+0).toString(16).toUpperCase()},'dec2hex2':function(ts){var hexequiv=new Array("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F");return hexequiv[(ts>>4)&0xF]+hexequiv[ts&0xF]},'dec2hex4':function(ts){var hexequiv=new Array("0","1","2","3","4","5","6","7","8","9","A","B","C","D","E","F");return hexequiv[(ts>>12)&0xF]+hexequiv[(ts>>8)&0xF]+hexequiv[(ts>>4)&0xF]+hexequiv[ts&0xF]},'convertCP2Char':function(ts){var outputString='';ts=ts.replace(/^\s+/,'');if(ts.length==0)return"";ts=ts.replace(/\s+/g,' ');var listArray=ts.split(' ');for(var i=0;i<listArray.length;i++){var n=parseInt(listArray[i],16);if(n<=0xFFFF)outputString+=String.fromCharCode(n);else if(n<=0x10FFFF){n-=0x10000;outputString+=String.fromCharCode(0xD800|(n>>10))+String.fromCharCode(0xDC00|(n&0x3FF))}else outputString+='!erreur '+unicode.dec2hex(n)+'!'}return(outputString)},'convertCP2DecNCR':function(ts){var outputString="";ts=ts.replace(/^\s+/,'');if(ts.length==0)return"";ts=ts.replace(/\s+/g,' ');var listArray=ts.split(' ');for(var i=0;i<listArray.length;i++){var n=parseInt(listArray[i],16);outputString+=('{\\u'+n+'}')}return(outputString)},'convertChar2CP':function(ts){var outputString="",haut=0,n=0;for(var i=0;i<ts.length;i++){var b=ts.charCodeAt(i);if(b<0||b>0xFFFF)outputString+='!erreur '+unicode.dec2hex(b)+'!';if(haut!=0){if(0xDC00<=b&&b<=0xDFFF){outputString+=unicode.dec2hex(0x10000+((haut-0xD800)<<10)+(b-0xDC00))+' ';haut=0;continue}else{outputString+='!erreur '+unicode.dec2hex(haut)+'!';haut=0}}if(0xD800<=b&&b<=0xDBFF)haut=b;else outputString+=unicode.dec2hex(b)+' '}return(outputString.replace(/ $/,''))},'convertDecNCR2CP':function(ts){var outputString='';ts=ts.replace(/\s/g,'');var listArray=ts.split(';');for(var i=0;i<listArray.length-1;i++){if(i>0)outputString+=' ';var n=parseInt(listArray[i].substring(2,listArray[i].length),10);outputString+=unicode.dec2hex(n)}return(outputString)}};if(!String.prototype.char2dec)String.prototype.char2dec=function(){return unicode.convertCP2DecNCR(unicode.convertChar2CP(this))};if(!String.prototype.dec2char)String.prototype.dec2char=function(){return unicode.convertCP2Char(unicode.convertDecNCR2CP(this))}})();

function doQuery(querykey,querynokeyword,from_lang,to_lang){
    var url = "http://translate.google.com/translate_t";
    var parameters = "hl=en&ie=UTF8&text="+escape(querynokeyword)+"&langpair="+from_lang+"|"+to_lang;
    output = "";
    var xmlhttp=new ActiveXObject("MSXML2.XMLHTTP");
    xmlhttp.onreadystatechange = function(){
      if (xmlhttp.readyState == 4) {
        test_string = xmlhttp.responseText;
          if(test_string == "") output = "error: Connection failed...\\line "+"querynokeyword="+querynokeyword+"\\line from_lang="+from_lang+"\\line to_lang="+to_lang+"\\line test_string="+test_string;;
        output = test_string.match(/<div id=result_box dir="ltr">(.*?)<\/div>/);
        if(output && output[1]) {
          output = output[1];
          output_match = output.match(/&#\d+;/g);
          if(output_match && output_match[0])
            for(var i=0; i<output_match.length;i++){
              output = output.replace(output_match[i],output_match[i].dec2char());
            }
          output = output.char2dec();
        } else output = "error: No translation found...\\line "+"querynokeyword="+querynokeyword+"\\line from_lang="+from_lang+"\\line to_lang="+to_lang+"\\line output="+output+"\\line test_string="+test_string;
        FARR.setStrValue("statusbar","Google Translate");
        output = pre_results.replace("$$1",output)+"}\\par }";
        FARR.setStrValue("window.richeditmode",output);
      }
    }
    xmlhttp.open("POST",url,true);
    xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    xmlhttp.setRequestHeader("Content-length", parameters.length);
    xmlhttp.setRequestHeader("Connection", "close");
    xmlhttp.send(parameters);
}

function onInit(c) {
  currentDirectory=c;
  var fso = new ActiveXObject("Scripting.FileSystemObject");
  var newFile = fso.OpenTextFile(currentDirectory+"\\fscript.rtf", 1, false, -2);
  var newResults = fso.OpenTextFile(currentDirectory+"\\results.rtf", 1, false, -2);
  pre_results = newResults.ReadAll();
  welcome_screen = newFile.ReadAll();
  newFile.Close();
  newResults.Close();
}

function onSearchBegin(querykey, explicit, queryraw, querynokeyword) {
  skip_value = 0;
  if(!explicit) {
    if(aliasstr.indexOf(querynokeyword)!=-1) {
      FARR.setState(querykey,1);
      FARR.emitResult(querykey,aliasstr, aliasstr, iconfilename,ALIAS,IMMEDIATE_DISPLAY,300);
      FARR.setState(querykey,0);
    }
    return;
  }
  if(queryraw.match(scriptregex2)) {
    FARR.setStrValue("statusbar","Google Translate");
    FARR.setStrValue("window.richeditmode",output);
    return;
  }
  FARR.setStrValue("statusbar","Google Translate");
  FARR.setStrValue("window.richeditmode",welcome_screen.replace("$$1",last_lang[0]+"|"+last_lang[1]));
}

function onRegexSearchMatch(querykey,querynokeyword) {
  var match_reg = querynokeyword.match(scriptregex);
  if(!match_reg[4]){
    last_lang[0] = match_reg[1];
    last_lang[1] = match_reg[2];
  }else{
    match_reg[1] = last_lang[0];
    match_reg[2] = last_lang[1];
    match_reg[3] = match_reg[4];
  }
  doQuery(querykey,match_reg[3],languages[match_reg[1]],languages[match_reg[2]]);
}
